#!/usr/bin/python3
# -*- coding: utf-8 -*-

##########################################
#                                        #
#          Pile : librairie de base		 #
#                                        #
##########################################

# créer une pile finie
# entrée : 
# sortie : p une pile
def creer_pile():
	return []	# on utilise la fonction len() des séquences pour garder la taille

# empiler un élément dans une pile
# entrée : p une pile
#        : e un élément
# sortie : le nombre d'éléments dans la pile
def empiler(p,e):
	p.append(e)
	return len(p)

# dépiler une pile
# entrée : p une pile
# sortie : e un élément
def depiler(p):
	assert len(p)>0
	return p.pop()

# renvoyer le nombre d'élément dans une pile
# entrée : p une pile
# sortie : n un entier
def taille(p):
	return len(p)

# dire si une pile est vide
# entrée : p une pile
# sortie : b un booléen
def est_vide(p):
	return len(p)==0		# possibilité d'utiliser la fonction taille()

# renvoyer la valeur de l'élément au sommet de la pile
# entrée : p une pile
# sortie : e un élément
def sommet(p):
	assert len(p)>0
	return p[-1]		# particularité de python, les indices négatifs démarrent de la fin de la séquence

###
# vos solutions 
##################

#########
# exo 7 #
#########

# créé à partir d'un fichier les piles qui y sont définies
# entrée : -
# sortie : 4 piles
def creationPiles():
    PATH="/chemin/qui/va/bien/"
    PATH="/DONNEES/Enseignement/2018-19/CPGE/01-Piles/"
    file = open(PATH+"CPGE-Info-Piles-TP.txt", 'r')
    line = file.readline()  # on passe le nom 'pile1'
    p1=creer_pile()
    line = file.readline()
    while line != '%\n':
        empiler(p1, line[:-1])  # on retire le '\n'
        line = file.readline()

    line = file.readline()  # on passe le nom 'pile2'
    p2=creer_pile()
    line = file.readline()
    while line != '%\n':
        empiler(p2, line[:-1])  # on retire le '\n'
        line = file.readline()
    
    line = file.readline()  # on passe le nom 'pile3'
    p3=creer_pile()
    line = file.readline()
    while line != '%\n':
        empiler(p3, line[:-1])  # on retire le '\n'
        line = file.readline()

    line = file.readline()  # on passe le nom 'pile4'
    p4=creer_pile()
    line = file.readline()
    while line != '%\n':
        empiler(p4, line[:-1])  # on retire le '\n'
        line = file.readline()

    file.close()
    return p1, p2, p3, p4

pile1, pile2, pile3, pile4 = creationPiles()
#########
# exo 8 #
#########

# mélange aléatoirement deux piles entre elles et renvoie la pile résultante
# entrée : p, q deux piles
# sortie : r une pile
import numpy
def melange(p,q):
    r=creer_pile()
    while not(est_vide(p)) and not(est_vide(q)):
        if numpy.random.randint(0,2)==0 :
            empiler(r,depiler(p))
        else: 
            empiler(r,depiler(q))
    while not(est_vide(q)):
        empiler(r,depiler(q))
    while not(est_vide(p)):
        empiler(r,depiler(p))
    return r

m1 = melange(pile1.copy(), pile2)   # on copie pile1 pour pouvoir la reutiliser
m2 = melange(pile1.copy(), pile3)   # on copie pile1 pour pouvoir la reutiliser
m3 = melange(pile1, pile4)


#########
# exo 9 #
#########

# évalue la valeur d'une expression mathématiques
# entrée : une liste contenant une expression mathématiques
# sortie : entier ou flottant
def eval_polo(exp):
    p = creer_pile()
    for t in exp:	# terme courant de l'expression
        if t=='-': 
            a=depiler(p)
            b=depiler(p)
            empiler(p,b-a)
        elif t=='*':
            a=depiler(p)
            b=depiler(p)
            empiler(p,b*a)
        else:
            empiler(p,t)
    return depiler(p)

# quelques verifications
eval_polo([2,1,'-'])					# =2-1
eval_polo([2,3,'*'])					# =2*3
eval_polo([2,1,4,5,'*','-','-'])	# =2-(1-4*5)
eval_polo([2,1,'*',4,5,'*','-'])	# =2*1-4*5
eval_polo([2,1,4,5,'-','*','-'])	# =2-1*(4-5)


# end of file : CPGE-Info-Piles-TP-corrige.py